/**
* @file
* Interface definitions for error handling functions
*/

/*
 * Copyright (c) 2009, Felix Opatz
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  * Neither the name of  nor the names of its contributors may be used to
 *    endorse or promote products derived from this software without specific
 *    prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef ERRORHANDLING_H
#define ERRORHANDLING_H

/**
* Enumeration of all errors that can be reported to the user.
*/
enum ErrorCodes
{
	ERROR_APP_ALREADY_STARTED,     /** Application already started       */
	ERROR_OPENING_CONFIG_FILE,     /** Opening configuration file failed */
	ERROR_INVALID_KEYWORD,         /** Invalid keyword encountered       */
	ERROR_MISSING_VALUE,           /** Configuration value is missing    */
	ERROR_INVALID_VALUE,           /** Configuration value is invalid    */
	ERROR_INVALID_LINE,            /** Unknown problem reading config    */
	ERROR_CREATING_PROCESS,        /** Process could not be created      */
	ERROR_NO_MEMORY,               /** No memory left                    */
	ERROR_REGISTER_HOTKEY_FAILED,  /** Registering HotKey failed         */
};

void ReportError(const enum ErrorCodes nErrorCode, ...);

#endif
